#!/usr/bin/perl -w

# This program counts received packets and, every ALRM period,
# displays the current count.

use strict;
use warnings;
 
use IO::Socket::INET;
 
# Send data immediately without buffering
$| = 1;
 
my $packets=0;

# this ALRM process whould display messages received each second
$SIG{ALRM} = sub {
    # start next signal count
    alarm(1);
    print "datagrams received=", $packets,"\n";  # display on multiple lines
#    print "datagrams received=", $packets,"   \r"; # display on one line
    $packets=0;
};

# Main routine - Receive and count the datagrams
my ($socket,$data);

#  Create a new UDP socket
$socket = new IO::Socket::INET (
    LocalPort => 4949,
    Proto        => 'udp'
)   or die "ERROR creating socket : $!\n";
 
my ($datagram,$flags);
alarm(1);

while (1) {
    $socket->recv($datagram,42,$flags);
    if (length($datagram) >0) { # sometimes no datagram, perhaps just timeout
        $packets++;
# for testing, print packets as they come in
#        print "from ", "socket->peerhost ", ":$datagram $packets\n";
      }
}
